﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace hra_hadik
{
    class Snake
    {
        private readonly List<Segment> segments;
        public static readonly int width = 10;
        public static readonly int height = 10;
        private int skore = 0;

        public Snake()
        {
            this.segments = new List<Segment>();

            Segment segment = new Segment(width, height, 0, 0);
            this.segments.Insert(0, segment);

            segment = new Segment(width, height, width, 0);
            this.segments.Insert(1, segment);

            //hlava hadika
            segment = new Segment(width, height, 2 * width, 0);
            this.segments.Insert(2, segment);
        }
        public bool RovnakySegment(Segment mySegment1, Segment mySgment2)
        {
            return ((mySegment1.X == mySgment2.X) && (mySegment1.Y == mySgment2.Y));
        }
        public bool PohniHadika()
        {


            //posunieme telo hadika
            for (int i = 0; i < this.PoziciaHlavy; i++)
            {
                this.segments[i] = this.segments[i + 1].Clone() as Segment;
            }

            //posunieme hlavu na novu poziciu
            switch (SmerHadika)
            {
                case Pohyb.Left:

                    this.segments[this.PoziciaHlavy].X -= width;

                    break;

                case Pohyb.Right:

                    this.segments[this.PoziciaHlavy].X += width;

                    break;

                case Pohyb.Up:

                    this.segments[this.PoziciaHlavy].Y -= height;

                    break;

                case Pohyb.Down:

                    this.segments[this.PoziciaHlavy].Y += height;

                    break;
            }

            //skontroluje ci hlava hadika sa nedotkla tela

            //posunieme zbytok tela
            for (int i = 0; i < this.PoziciaHlavy; i++)
            {
                if (this.RovnakySegment(this.segments[i], this.segments[this.PoziciaHlavy]))
                {
                    return false;
                }
            }

            return true;

        }
        public void PridajSegmentHadika()
        {
            Segment segment = new Segment(width, height, -10, -10);
            this.segments.Insert(0, segment);
            this.skore += 10;
        }
        public List<Segment> ToSegments
        {
            get { return this.segments; }
        }

        public int PoziciaHlavy
        {
            get { return this.segments.Count - 1; }
        }
        public int Skore
        {
            get { return this.skore; }
        }
        public Pohyb SmerHadika { get; set; }
        public enum Pohyb
        {
            Left,
            Right,
            Up,
            Down
        }
    }
}
