﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Threading;

namespace hra_hadik
{    
    class SnakeGame
    {
        private readonly static int WidtHracejPlochy = 500;
        private readonly static int HeightHracejPlochy = 500;
        private readonly PictureBox canvas;
        private readonly Snake hadik = new Snake();
        private readonly SolidBrush farbaTela = new SolidBrush(Color.LightBlue);
        private readonly SolidBrush farbaTextu = new SolidBrush(Color.Gray);
        private readonly SolidBrush farbaJedla = new SolidBrush(Color.Red);
        Segment jedlo1 = new Segment(Snake.width, Snake.height, 50, 50);
        Random random = new Random();

        public SnakeGame(PictureBox canvas)
        {
            this.canvas = canvas;         

            this.hadik.SmerHadika = Snake.Pohyb.Right;     
            
            this.canvas.Paint += new PaintEventHandler(canvas_Paint);

        }
       /// <summary>
       /// nastavime novy smer pre hadika
       /// </summary>
       /// <param name="novySmer"></param>
        public void NastavSmer(hra_hadik.Snake.Pohyb novySmer)
        {
            this.hadik.SmerHadika = novySmer;          
        }
        /// <summary>
        /// Overime ci je hadik v hracom poli
        /// </summary>
        /// <returns></returns>
        public bool KoniecHry()
        {
            if (this.hadik.ToSegments[this.hadik.PoziciaHlavy].X < 0 || this.hadik.ToSegments[this.hadik.PoziciaHlavy ].Y < 0)
            {
                return true;
            }
            if (this.hadik.ToSegments[this.hadik.PoziciaHlavy].X > WidtHracejPlochy  || this.hadik.ToSegments[this.hadik.PoziciaHlavy].Y > HeightHracejPlochy)
            {
                return true;
            }

            return false;

        }
        /// <summary>
        /// Vykreslime hracie pole
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void canvas_Paint(object sender, PaintEventArgs e)
        {

               
            e.Graphics.DrawString("Score :"+this.hadik.Skore, new Font(FontFamily.GenericSansSerif, 12, FontStyle.Bold), this.farbaTextu,0,0);
               
            e.Graphics.FillRectangle(this.farbaJedla, jedlo1.ToRectangle());

            if (this.KoniecHry())
            {
                e.Graphics.DrawString("Koniec hry", new Font(FontFamily.GenericSansSerif, 24, FontStyle.Bold), this.farbaTextu, 150, 150);
                return;
            }

            if (this.hadik.PohniHadika() == false)
            {
                e.Graphics.DrawString("Koniec hry", new Font(FontFamily.GenericSansSerif, 24, FontStyle.Bold), this.farbaTextu, 150, 150);
                return;
            }
            if(this.hadik.RovnakySegment(this.hadik.ToSegments[this.hadik.PoziciaHlavy],this.jedlo1))
            {
                jedlo1 = new Segment(Snake.width, Snake.height, Snake.width * this.random.Next(0, 50), Snake.height * this.random.Next(0, 50));
                this.hadik.PridajSegmentHadika();
            }

            foreach (Segment telo in this.hadik.ToSegments)
                e.Graphics.FillRectangle(this.farbaTela, telo.ToRectangle());

            Thread.Sleep(20);
           
            //budeme zvysovat rychlost,ak sa zmeni skore
            if(this.hadik.Skore < 100)
                Thread.Sleep(20);
            if (this.hadik.Skore < 150)
                Thread.Sleep(20);
            if (this.hadik.Skore < 200)
                Thread.Sleep(20);
            if (this.hadik.Skore < 250)
                Thread.Sleep(20);
            if (this.hadik.Skore < 300)
                Thread.Sleep(20);
            if (this.hadik.Skore < 350)
                Thread.Sleep(20);
            
            e.Graphics.DrawString("www.projectik.eu", new Font(FontFamily.GenericSansSerif, 10, FontStyle.Bold), this.farbaTextu, 150, 150);
            
           this.canvas.Invalidate();
            
        }
    }
}
